package structure;

import java.util.ArrayList;

/**
 * StateTree.class
 * @author vsmital
 * Implementuje strom pro bread-first search.
 */
public class Queue {
	/**
	 * Seznam expandovanych uzlu.
	 */
	private ArrayList queue = null;
	
	/**
	 * Konstruktor
	 */
	public Queue() {
		queue = new ArrayList();
	}
	
	/**
	 * Metoda pro pridavani uzlu do fronty.
	 * @param state - vkladany uzel.
	 */
	public void addNode(State state) {
		queue.add(state);
	}
	
	/**
	 * Metoda pro odebirani uzlu z fronty.
	 * @param index - index odebiraneho objektu v ramci fronty.
	 */
	public State removeNode(int index) {
		State state = (State) queue.remove(index);
		return state;
	}
	
	/*public boolean contains(State state) {
		if (queue.contains(state))
			return true;
		else
			return false;
	}*/
	
	public boolean contains(State state) {
		boolean status = false;
		int size = queue.size();
		for(int i = 0; i < size; i++) {
			State state1 = (State) queue.get(i);
			if(state1.getMisNum() == state.getMisNum() &&
					state1.getCanNum() == state.getCanNum() &&
					state1.getBoatNum() == state.getBoatNum())
			{
				status = true;
				break;
			}
		}
		return status;
	}
	
	
}
